# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify Alma, CentOS, CentOS Stream and Rocky Linux as rhel
%if "%{__distinit}" == "a" || "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "cs" || "%{__distinit}" == "rl"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# TODO: BR: perl(B::C) when available

Name:		perl-Sub-Name
Version:	0.27
Release:	1.%{__distinit}%{__distvers}
Summary:	Name - or rename - a sub
License:	GPL-1.0-or-later OR Artistic-1.0-Perl
URL:		https://metacpan.org/release/Sub-Name
Source0:	https://cpan.metacpan.org/modules/by-module/Sub/Sub-Name-%{version}.tar.gz
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	gcc
BuildRequires:	make
BuildRequires:	perl-devel
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(ExtUtils::MakeMaker)
# Module Runtime
BuildRequires:	perl(Exporter)
BuildRequires:	perl(strict)
BuildRequires:	perl(warnings)
BuildRequires:	perl(XSLoader)
# Test Suite
BuildRequires:	perl(B)
BuildRequires:	perl(B::Deparse)
BuildRequires:	perl(Carp)
BuildRequires:	perl(feature)
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(if)
BuildRequires:	perl(Test::More)
# Optional Tests
BuildRequires:	perl(CPAN::Meta) >= 2.120900
BuildRequires:	perl(Devel::CheckBin)
# Runtime
%if 0%{?fedora} < 38 && 0%{?rhel} < 10
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%endif

# Don't "provide" private perl objects
%{?perl_default_filter}

%description
This module allows one to "name" or rename subroutines, including anonymous
ones.

Note that this is mainly for aid in debugging; you still cannot call the sub
by the new name (without some deep magic).

%prep
%setup -q -n Sub-Name-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor optimize="%{optflags}"
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
find %{buildroot} -type f -name '*.bs' -empty -delete
%{_fixperms} -c %{buildroot}

%check
make test

%files
%license LICENCE
%doc Changes CONTRIBUTING README
%{perl_vendorarch}/auto/Sub/
%{perl_vendorarch}/Sub/
%{_mandir}/man3/Sub::Name.3*

%changelog
* Sat Apr 29 2023 Paul Howarth <paul@city-fan.org> - 0.27-1
- Update to 0.27
  - Skip quote-separator tests on newer perls that deprecate this behaviour

* Mon Mar  6 2023 Paul Howarth <paul@city-fan.org> - 0.26-12
- Use SPDX-format license tag

* Wed Jun  1 2022 Paul Howarth <paul@city-fan.org> - 0.26-9
- Perl 5.36 rebuild

* Fri May 21 2021 Paul Howarth <paul@city-fan.org> - 0.26-6
- Perl 5.34 rebuild

* Thu Jun 25 2020 Paul Howarth <paul@city-fan.org> - 0.26-3
- Perl 5.32 rebuild

* Sun Oct  6 2019 Paul Howarth <paul@city-fan.org> - 0.26-1
- Update to 0.26
  - %%DB::sub is now populated correctly for sub names with wide characters or
    nulls (GH#9)
  - Better Perl 5.6 compatibility by lowering prereqs of core modules
  - Test for renaming lexical subs, which should work on Perl 5.22+ (GH#10)
  - Small internal changes to bring implementation in line with changes to
    Sub::Util
  - Fix "Undefined symbol "DPPP_my_croak_xs_usage"" error on some perls
    (CPAN RT#125158)

* Fri May 31 2019 Paul Howarth <paul@city-fan.org> - 0.21-10
- Perl 5.30 rebuild

* Wed Jun 27 2018 Paul Howarth <paul@city-fan.org> - 0.21-7
- Perl 5.28 rebuild

* Sun Aug  6 2017 Paul Howarth <paul@city-fan.org> - 0.21-5
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl

* Sun Jun  4 2017 Paul Howarth <paul@city-fan.org> - 0.21-3
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section
  - Drop workaround for building with Test::More < 0.88
  - BR: perl-devel unconditionally

* Sun Oct  2 2016 Paul Howarth <paul@city-fan.org> - 0.21-1
- Update to 0.21
  - Fix occasional segmentation fault on OpenBSD when malloc randomization
    causes nameptr to be at the beginning of the page (CPAN RT#117072)

* Fri Aug 19 2016 Paul Howarth <paul@city-fan.org> - 0.19-1
- Update to 0.19
  - Fix checking of SvUTF8 flag

* Tue Aug 16 2016 Paul Howarth <paul@city-fan.org> - 0.18-1
- Update to 0.18
  - Support binary and unicode symbol names (PR#8)
  - Fixed parsing error where the name contains a single colon but the last
    separator is ::
- Update patch for building with old Test::More versions

* Tue May 17 2016 Paul Howarth <paul@city-fan.org> - 0.15-2
- BR: perl-generators where available
- Simplify find commands using -empty and -delete

* Wed Mar 16 2016 Paul Howarth <paul@city-fan.org> - 0.15-1
- Update to 0.15
  - Fix uninitialized warning in test on perls < 5.8.6 (CPAN RT#104510)
  - Repository moved to the github p5sagit organization (the primary is on
    shadowcat, mirrored to github)
- Explicitly BR: perl-devel, needed for EXTERN.h

* Wed Jun 17 2015 Paul Howarth <paul@city-fan.org> - 0.14-2
- Perl 5.22 rebuild

* Fri Apr 24 2015 Paul Howarth <paul@city-fan.org> - 0.14-1
- Update to 0.14
  - Remove mandatory dependencies for optional test
  - Mark the test with B::C as TODO, as it seems to fail frequently and should
    not block normal installations

* Sun Mar 29 2015 Paul Howarth <paul@city-fan.org> - 0.13-1
- Update to 0.13
  - Fix optional test of interaction with B::C that sometimes invalidly failed
- Update patch to support building with old Test::More versions

* Tue Sep 23 2014 Paul Howarth <paul@city-fan.org> - 0.12-1
- Update to 0.12
  - Move variable declaration to fix warning under
    -Werror=declaration-after-statement, to allow compilation under MSVC (GH#3)
  - Converted distribution packaging to Dist::Zilla
  - Fix licence in LICENSE and pod
- Package new upstream CONTRIBUTING and LICENSE files
- Classify buildreqs by usage
- Drop explicit requires, no longer needed

* Thu Aug 28 2014 Paul Howarth <paul@city-fan.org> - 0.09-2
- Perl 5.20 rebuild

* Thu Aug 14 2014 Paul Howarth <paul@city-fan.org> - 0.09-1
- Update to 0.09
  - Copy the contents of the %%DB::sub entry if it exists; fixes
    Devel::NYTProf's anon sub handling (CPAN RT#50524)
- Drop upstreamed debugger patch
- Add patch to support building with Test::More < 0.88

* Mon Aug  4 2014 Paul Howarth <paul@city-fan.org> - 0.08-1
- Update to 0.08
  - Fix leak when setting a fully-qualified name (GH#1)
- Update debugger patch

* Mon Jul 14 2014 Paul Howarth <paul@city-fan.org> - 0.07-1
- Update to 0.07
  - Skip optional test if B::C 1.48 is not installed
- Drop workaround for skipping perl compiler test

* Fri Jul 11 2014 Paul Howarth <paul@city-fan.org> - 0.06-1
- Update to 0.06
  - Do not change the string arg in XS, use copy instead (CPAN RT#96893)
  - Add README make target
  - Add more distribution metadata
- This release by ETHER → update source URL
- Update debugger patch (CPAN RT#96893)
- Don't try to run the perl compiler test as it fails with the bundled
  compiler in perl 5.8.x
- Drop %%defattr, redundant since rpm 4.4

* Sun Jul 21 2013 Paul Howarth <paul@city-fan.org> - 0.05-10
- Perl 5.18 rebuild

* Tue Jun 12 2012 Paul Howarth <paul@city-fan.org> - 0.05-7
- Don't need to remove empty directories from the buildroot
- Drop support for old distributions prior to FC-3:
  - Don't need to define %%{perl_vendorarch}
  - Don't need RPATH kludge
  - Use DESTDIR rather than PERL_INSTALL_ROOT
  - Use %%{_fixperms} macro rather than our own chmod incantation

* Sat Feb 18 2012 Paul Howarth <paul@city-fan.org> - 0.05-6
- Add buildreqs for Perl core modules that might be dual-lived
- Explicit requires for "use base XXX;" only required prior to rpm 4.9

* Tue Jun 21 2011 Paul Howarth <paul@city-fan.org> - 0.05-4
- Rebuild for perl 5.14.1 in Rawhide
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Fri Oct 15 2010 Paul Howarth <paul@city-fan.org> - 0.05-3
- Add patch for CPAN RT#50524 (copy contents of %%DB::sub entry if it exists)

* Fri Oct  1 2010 Paul Howarth <paul@city-fan.org> - 0.05-2
- Rebuild for gcc bug (#634757)

* Wed Sep  8 2010 Paul Howarth <paul@city-fan.org> - 0.05-1
- Update to 0.05
  - Stop using the padlist to refcount GVs (CPAN RT#42725)
  - Stop using the deprecated PL_no_symref (CPAN RT#57843)
  - Support perl >= 5.13.3 by using CvGV_set interface there (CPAN RT#59558)
- This release by FLORA -> update source URL
- BR: perl(Test::More)
- Explicitly require perl(DynaLoader) and perl(Exporter) (use base xxx;)
- Add rpath-removal kludge for ancient distros

* Wed Jun 23 2010 Paul Howarth <paul@city-fan.org> - 0.04-7
- Rebuild for perl 5.12.1 in Rawhide

* Tue May 11 2010 Paul Howarth <paul@city-fan.org> - 0.04-6
- Fix dist tag for RHEL-6 Beta

* Thu Feb 11 2010 Paul Howarth <paul@city-fan.org> - 0.04-5
- Add provides filter
- Dist tag for Rawhide no longer needs special-casing

* Mon Aug 10 2009 Paul Howarth <paul@city-fan.org> - 0.04-4
- Import from Fedora

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.04-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.04-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Sun Aug 03 2008 Chris Weyl <cweyl@alumni.drew.edu> - 0.04-1
- Update to 0.04

* Sat Mar 15 2008 Chris Weyl <cweyl@alumni.drew.edu> - 0.03-1
- Update to 0.03

* Tue Mar  4 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 0.02-5
- Rebuild for new perl

* Mon Feb 18 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 0.02-4.1
- Autorebuild for GCC 4.3

* Tue Oct 16 2007 Tom "spot" Callaway <tcallawa@redhat.com> - 0.02-3.1
- Correct license tag
- Add BR: perl(ExtUtils::MakeMaker)

* Tue Aug 21 2007 Chris Weyl <cweyl@alumni.drew.edu> - 0.02-3
- Bump

* Wed Sep 06 2006 Chris Weyl <cweyl@alumni.drew.edu> - 0.02-2
- Bump

* Sat Sep 02 2006 Chris Weyl <cweyl@alumni.drew.edu> - 0.02-1
- Specfile autogenerated by cpanspec 1.69.1
